using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using System.Collections;
using System.Reflection;
 
namespace OlSentMail
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("610286CA-22C9-4ABE-9B71-37C8449CCFB5"), ProgId("OlSentMail.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule(System.ComponentModel.IContainer container)
        {
            // This call is required by the Component Designer
            container.Add(this);
            InitializeComponent();
 
            // TODO: Add any initialization after the InitializeComponent call
        }

		private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
		private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;

		private AddinExpress.MSO.ADXOlInspectorCommandBar adxOlInspectorCommandBar1;
 
        public AddinModule()
        {
            InitializeComponent();
        }
 
        // Add-in Module Implementation
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxOlInspectorCommandBar1 = new AddinExpress.MSO.ADXOlInspectorCommandBar(this.components);
			this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
			this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
			// 
			// adxOlInspectorCommandBar1
			// 
			this.adxOlInspectorCommandBar1.CommandBarName = "Sent Mail Command Bar";
			this.adxOlInspectorCommandBar1.CommandBarTag = "a37a3837-46d1-423e-8e4e-eabb4a64baaa";
			this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarButton1);
			this.adxOlInspectorCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
			this.adxOlInspectorCommandBar1.Temporary = true;
			this.adxOlInspectorCommandBar1.UpdateCounter = 6;
			// 
			// adxCommandBarButton1
			// 
			this.adxCommandBarButton1.Caption = "Process Sent Mail";
			this.adxCommandBarButton1.ControlTag = "4489fa9c-aa7e-42ae-9e7a-b552071836a1";
			this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
			this.adxCommandBarButton1.Temporary = true;
			this.adxCommandBarButton1.UpdateCounter = 2;
			this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
			// 
			// adxOutlookEvents
			// 
			this.adxOutlookEvents.InspectorActivate += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorActivate);
			// 
			// AddinModule
			// 
			this.AddinName = "OlSentMail";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
			this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private Outlook._Application OutlookApp
		{
			get
			{
				return HostApplication as Outlook._Application;
			}
		}

		private SortedList activeFolders = new SortedList();
		private string sentFullFolderName;

		private void adxOutlookEvents_InspectorActivate(object sender, object inspector, string folderName)
		{
			AddinExpress.MSO.ADXOlInspectorCommandBar cmdBar = 
				CommandBarByName("Sent Mail Command Bar") as AddinExpress.MSO.ADXOlInspectorCommandBar;
			if (cmdBar != null)
			{
				if (folderName.IndexOf(sentFullFolderName) >= 0)
				{
					cmdBar.Enabled = true;
					cmdBar.Visible = true;
				}
				else
				{
					cmdBar.Visible = false;
					cmdBar.Enabled = false;
				}
			}
		}

		private void adxCommandBarButton1_Click(object sender)
		{
			MessageBox.Show("Here do something.");
		}

		private string GetFullFolderName(object folder)
		{
			string fullName = String.Empty, tmp; 
			object _folder = folder;
			IntPtr ifolder = new IntPtr();
			Guid folderGuid = new Guid("00063006-0000-0000-C000-000000000046");

			IntPtr unk = Marshal.GetIUnknownForObject(folder);
			Marshal.QueryInterface(unk, ref folderGuid, out ifolder);
			Marshal.Release(unk);
			while(ifolder != IntPtr.Zero)
			{
				Marshal.Release(ifolder); ifolder = IntPtr.Zero;
				tmp = Convert.ToString(folder.GetType().InvokeMember("Name", BindingFlags.GetProperty, null, folder, null));
				fullName = "\\"+tmp+fullName;
				try
				{
					_folder = folder.GetType().InvokeMember("Parent", BindingFlags.GetProperty, null, folder, null);
				}
				catch
				{
					_folder = null;
				}
				Marshal.ReleaseComObject(folder);
				if (_folder != null)
				{
					unk = Marshal.GetIUnknownForObject(_folder);
					Marshal.QueryInterface(unk, ref folderGuid, out ifolder);
					Marshal.Release(unk);
					folder = _folder;
				}
			}
			if (fullName != String.Empty && fullName[0] == '\\') fullName = fullName.Remove(0, 1);
			Marshal.ReleaseComObject(folder);

			return fullName;
		}

		private void AddinModule_AddinStartupComplete(object sender, System.EventArgs e)
		{
			Outlook._NameSpace _namespace = null;
			Outlook.MAPIFolder sentFolder = null;
			try
			{
				_namespace = OutlookApp.GetNamespace("MAPI");
				sentFolder = _namespace.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderSentMail);
				sentFullFolderName = GetFullFolderName(sentFolder);
			}
			finally
			{
				if (_namespace != null) 
					Marshal.ReleaseComObject(_namespace);
			}
		}
 
    }
}

